/*
 * © 2017 LogMeIn, Inc. All Rights Reserved.
 * All rights reserved.
 * 
 * This software is distributed under the terms and conditions of the
 * LogMeIn SDK License Agreement. Please see file LICENSE for details.
 * 
 * Auto-generated file.
 */


using System;

namespace LogMeIn.GoToMeeting.Api.Common
{
    /// <summary>
    /// The exception thrown when an API error occurs.
    /// </summary>
    public class ApiException : Exception
    {
        private int errorCode = 0;

        /// <summary>
        /// Initializes a new instance of the ApiException class.
        /// </summary>
        /// <param name="message">A string describing the error.</param>
        public ApiException(string message)
            : this(0, message)
        { }

        /// <summary>
        /// Initializes a new instance of the ApiException class.
        /// </summary>
        /// <param name="errorCode">The status code of the error that occured.
        /// Can be HTML status code or another number for other types of exceptions.</param>
        /// <param name="message">A string describing the error.</param>
        public ApiException(int errorCode, string message)
            : base(message)
        {
            this.errorCode = errorCode;
        }

        /// <summary>
        /// Initializes a new instance of the ApiException class.
        /// </summary>
        /// <param name="errorCode">The status code of the error that occured.
        /// Can be HTML status code or another number for other types of exceptions.</param>
        /// <param name="e">The inner exception</param>
        public ApiException(int errorCode, Exception e)
            : base("Error occurred", e)
        {
            this.errorCode = errorCode;
        }

        /// <summary>
        /// Initializes a new instance of the ApiException class.
        /// </summary>
        /// <param name="e">The inner exception</param>
        public ApiException(Exception e)
            : this(0, e)
        { }

        /// <summary>
        /// Gets the status code of the error that occurred.
        /// Can be HTML status code or another number for other types of exceptions.
        /// </summary>
        public int ErrorCode
        {
            get
            {
                return errorCode;
            }
        }
    }
}
