/*
 * © 2017 LogMeIn, Inc. All Rights Reserved.
 * All rights reserved.
 * 
 * This software is distributed under the terms and conditions of the
 * LogMeIn SDK License Agreement. Please see file LICENSE for details.
 * 
 * Auto-generated file.
 */


using System;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using LogMeIn.GoToMeeting.Api.Common;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;


namespace LogMeIn.GoToMeeting.Api.Model
{
    /// <summary>
    /// Describes a collection of organizers categorized by department or job function, for example. Can be a subgroup of a larger group.
    /// </summary>
    public class Group
    {
        /// <summary>
        /// The key of this group
        /// </summary>
        public long? groupkey { get; set; }

        /// <summary>
        /// The name of this group
        /// </summary>
        public string groupName { get; set; }

        /// <summary>
        /// The key of the parent group this group belongs to. Identical with the groupkey if this group is not a subgroup
        /// </summary>
        public long? parentKey { get; set; }

        /// <summary>
        /// The status of this group, i.e. whether the organizers assigned to it are able to host meetings
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public Status? status { get; set; }

        /// <summary>
        /// The number of organizers assigned to this group
        /// </summary>
        public int? numOrganizers { get; set; }


        /// <summary>
        /// Returns a string representing the current object.
        /// </summary>
        /// <returns>The Json serialization of the current object.</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class Group {\n");
            var groupkeyString = groupkey.Stringify();
            if (!string.IsNullOrEmpty(groupkeyString))
                sb.AppendFormat("  groupkey: {0}\n", groupkeyString);
            var groupNameString = groupName.Stringify();
            if (!string.IsNullOrEmpty(groupNameString))
                sb.AppendFormat("  groupName: {0}\n", groupNameString);
            var parentKeyString = parentKey.Stringify();
            if (!string.IsNullOrEmpty(parentKeyString))
                sb.AppendFormat("  parentKey: {0}\n", parentKeyString);
            var statusString = status.Stringify();
            if (!string.IsNullOrEmpty(statusString))
                sb.AppendFormat("  status: {0}\n", statusString);
            var numOrganizersString = numOrganizers.Stringify();
            if (!string.IsNullOrEmpty(numOrganizersString))
                sb.AppendFormat("  numOrganizers: {0}\n", numOrganizersString);
            sb.Append("}\n");
            return sb.ToString();
        }
    }

}
