/*
 * © 2017 LogMeIn, Inc. All Rights Reserved.
 * All rights reserved.
 * 
 * This software is distributed under the terms and conditions of the
 * LogMeIn SDK License Agreement. Please see file LICENSE for details.
 * 
 * Auto-generated file.
 */


using System;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using LogMeIn.GoToMeeting.Api.Common;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;


namespace LogMeIn.GoToMeeting.Api.Model
{
    /// <summary>
    /// Describes a historical meeting within specified dates for a specified group.
    /// </summary>
    public class HistoricalMeetingByGroup
    {
        /// <summary>
        /// The time the meeting instance started
        /// </summary>
        public DateTime? startTime { get; set; }

        /// <summary>
        /// The surname of the meeting organizer
        /// </summary>
        public string lastName { get; set; }

        /// <summary>
        /// The duration of the meeting session in minutes
        /// </summary>
        public string duration { get; set; }

        /// <summary>
        /// The number of attendees at the meeting instance
        /// </summary>
        public string numAttendees { get; set; }

        /// <summary>
        /// The key of the company account
        /// </summary>
        public string accountKey { get; set; }

        /// <summary>
        /// The meeting organizer's email address
        /// </summary>
        public string email { get; set; }

        /// <summary>
        /// The subject of the meeting
        /// </summary>
        public string subject { get; set; }

        /// <summary>
        /// The current language setting of the organizer in the web portal
        /// </summary>
        public string locale { get; set; }

        /// <summary>
        /// The key of the meeting organizer
        /// </summary>
        public string organizerKey { get; set; }

        /// <summary>
        /// The meeting ID
        /// </summary>
        public string meetingId { get; set; }

        /// <summary>
        /// The meeting type
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public MeetingType? meetingType { get; set; }

        /// <summary>
        /// The meeting organizer's first name
        /// </summary>
        public string firstName { get; set; }

        /// <summary>
        /// The time the meeting instance ended
        /// </summary>
        public DateTime? endTime { get; set; }

        /// <summary>
        /// The name of the group
        /// </summary>
        public string groupName { get; set; }


        /// <summary>
        /// Returns a string representing the current object.
        /// </summary>
        /// <returns>The Json serialization of the current object.</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class HistoricalMeetingByGroup {\n");
            var startTimeString = startTime.Stringify();
            if (!string.IsNullOrEmpty(startTimeString))
                sb.AppendFormat("  startTime: {0}\n", startTimeString);
            var lastNameString = lastName.Stringify();
            if (!string.IsNullOrEmpty(lastNameString))
                sb.AppendFormat("  lastName: {0}\n", lastNameString);
            var durationString = duration.Stringify();
            if (!string.IsNullOrEmpty(durationString))
                sb.AppendFormat("  duration: {0}\n", durationString);
            var numAttendeesString = numAttendees.Stringify();
            if (!string.IsNullOrEmpty(numAttendeesString))
                sb.AppendFormat("  numAttendees: {0}\n", numAttendeesString);
            var accountKeyString = accountKey.Stringify();
            if (!string.IsNullOrEmpty(accountKeyString))
                sb.AppendFormat("  accountKey: {0}\n", accountKeyString);
            var emailString = email.Stringify();
            if (!string.IsNullOrEmpty(emailString))
                sb.AppendFormat("  email: {0}\n", emailString);
            var subjectString = subject.Stringify();
            if (!string.IsNullOrEmpty(subjectString))
                sb.AppendFormat("  subject: {0}\n", subjectString);
            var localeString = locale.Stringify();
            if (!string.IsNullOrEmpty(localeString))
                sb.AppendFormat("  locale: {0}\n", localeString);
            var organizerKeyString = organizerKey.Stringify();
            if (!string.IsNullOrEmpty(organizerKeyString))
                sb.AppendFormat("  organizerKey: {0}\n", organizerKeyString);
            var meetingIdString = meetingId.Stringify();
            if (!string.IsNullOrEmpty(meetingIdString))
                sb.AppendFormat("  meetingId: {0}\n", meetingIdString);
            var meetingTypeString = meetingType.Stringify();
            if (!string.IsNullOrEmpty(meetingTypeString))
                sb.AppendFormat("  meetingType: {0}\n", meetingTypeString);
            var firstNameString = firstName.Stringify();
            if (!string.IsNullOrEmpty(firstNameString))
                sb.AppendFormat("  firstName: {0}\n", firstNameString);
            var endTimeString = endTime.Stringify();
            if (!string.IsNullOrEmpty(endTimeString))
                sb.AppendFormat("  endTime: {0}\n", endTimeString);
            var groupNameString = groupName.Stringify();
            if (!string.IsNullOrEmpty(groupNameString))
                sb.AppendFormat("  groupName: {0}\n", groupNameString);
            sb.Append("}\n");
            return sb.ToString();
        }
    }

}
