/*
 * © 2017 LogMeIn, Inc. All Rights Reserved.
 * All rights reserved.
 * 
 * This software is distributed under the terms and conditions of the
 * LogMeIn SDK License Agreement. Please see file LICENSE for details.
 * 
 * Auto-generated file.
 */


using System;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using LogMeIn.GoToMeeting.Api.Common;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;


namespace LogMeIn.GoToMeeting.Api.Model
{
    /// <summary>
    /// Describes a given meeting.
    /// </summary>
    public class MeetingById
    {
        /// <summary>
        /// DEPRECATED. Returns an empty string ''
        /// </summary>
        [Obsolete]
        public DateTime? createTime { get; set; }

        /// <summary>
        /// Indicates whether a password is required to join the meeting
        /// </summary>
        public bool? passwordRequired { get; set; }

        /// <summary>
        /// The meeting status, i.e whether the meeting is running or not
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public MeetingStatus? status { get; set; }

        /// <summary>
        /// The subject of the meeting
        /// </summary>
        public string subject { get; set; }

        /// <summary>
        /// The ending time of the meeting
        /// </summary>
        public DateTime? endTime { get; set; }

        /// <summary>
        /// Audio options of the meeting
        /// </summary>
        public string conferenceCallInfo { get; set; }

        /// <summary>
        /// The meeting starting time
        /// </summary>
        public DateTime? startTime { get; set; }

        /// <summary>
        /// The duration of the meeting in minutes
        /// </summary>
        public int? duration { get; set; }

        /// <summary>
        /// The maximum number of participants allowed at the meeting
        /// </summary>
        public int? maxParticipants { get; set; }

        /// <summary>
        /// The meeting ID
        /// </summary>
        public long? meetingId { get; set; }

        /// <summary>
        /// The meeting ID. Field retained for backwards compatibility reasons
        /// </summary>
        public long? meetingKey { get; set; }

        /// <summary>
        /// The meeting type
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public MeetingType? meetingType { get; set; }

        /// <summary>
        /// The meeting ID. Field retained for backwards compatibility reasons
        /// </summary>
        public long? uniqueMeetingId { get; set; }

        /// <summary>
        /// The co-organizer keys of users that also can host the meeting.
        /// </summary>
        public List<string> coorganizerKeys { get; set; }


        /// <summary>
        /// Returns a string representing the current object.
        /// </summary>
        /// <returns>The Json serialization of the current object.</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class MeetingById {\n");
            var createTimeString = createTime.Stringify();
            if (!string.IsNullOrEmpty(createTimeString))
                sb.AppendFormat("  createTime: {0}\n", createTimeString);
            var passwordRequiredString = passwordRequired.Stringify();
            if (!string.IsNullOrEmpty(passwordRequiredString))
                sb.AppendFormat("  passwordRequired: {0}\n", passwordRequiredString);
            var statusString = status.Stringify();
            if (!string.IsNullOrEmpty(statusString))
                sb.AppendFormat("  status: {0}\n", statusString);
            var subjectString = subject.Stringify();
            if (!string.IsNullOrEmpty(subjectString))
                sb.AppendFormat("  subject: {0}\n", subjectString);
            var endTimeString = endTime.Stringify();
            if (!string.IsNullOrEmpty(endTimeString))
                sb.AppendFormat("  endTime: {0}\n", endTimeString);
            var conferenceCallInfoString = conferenceCallInfo.Stringify();
            if (!string.IsNullOrEmpty(conferenceCallInfoString))
                sb.AppendFormat("  conferenceCallInfo: {0}\n", conferenceCallInfoString);
            var startTimeString = startTime.Stringify();
            if (!string.IsNullOrEmpty(startTimeString))
                sb.AppendFormat("  startTime: {0}\n", startTimeString);
            var durationString = duration.Stringify();
            if (!string.IsNullOrEmpty(durationString))
                sb.AppendFormat("  duration: {0}\n", durationString);
            var maxParticipantsString = maxParticipants.Stringify();
            if (!string.IsNullOrEmpty(maxParticipantsString))
                sb.AppendFormat("  maxParticipants: {0}\n", maxParticipantsString);
            var meetingIdString = meetingId.Stringify();
            if (!string.IsNullOrEmpty(meetingIdString))
                sb.AppendFormat("  meetingId: {0}\n", meetingIdString);
            var meetingKeyString = meetingKey.Stringify();
            if (!string.IsNullOrEmpty(meetingKeyString))
                sb.AppendFormat("  meetingKey: {0}\n", meetingKeyString);
            var meetingTypeString = meetingType.Stringify();
            if (!string.IsNullOrEmpty(meetingTypeString))
                sb.AppendFormat("  meetingType: {0}\n", meetingTypeString);
            var uniqueMeetingIdString = uniqueMeetingId.Stringify();
            if (!string.IsNullOrEmpty(uniqueMeetingIdString))
                sb.AppendFormat("  uniqueMeetingId: {0}\n", uniqueMeetingIdString);
            var coorganizerKeysString = coorganizerKeys.Stringify();
            if (!string.IsNullOrEmpty(coorganizerKeysString))
                sb.AppendFormat("  coorganizerKeys: {0}\n", coorganizerKeysString);
            sb.Append("}\n");
            return sb.ToString();
        }
    }

}
