/*
 * © 2017 LogMeIn, Inc. All Rights Reserved.
 * All rights reserved.
 * 
 * This software is distributed under the terms and conditions of the
 * LogMeIn SDK License Agreement. Please see file LICENSE for details.
 * 
 * Auto-generated file.
 */


using System;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using LogMeIn.GoToMeeting.Api.Common;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;


namespace LogMeIn.GoToMeeting.Api.Model
{
    /// <summary>
    /// Describes a meeting scheduled by a specified organizer
    /// </summary>
    public class MeetingByOrganizer
    {
        /// <summary>
        /// The starting time of the meeting
        /// </summary>
        public DateTime? startTime { get; set; }

        /// <summary>
        /// DEPRECATED. Returns an empty string ''
        /// </summary>
        [Obsolete]
        public DateTime? createTime { get; set; }

        /// <summary>
        /// The meeting ID
        /// </summary>
        public long? meetingid { get; set; }

        /// <summary>
        /// The maximum number of participants allowed at the meeting
        /// </summary>
        public int? maxParticipants { get; set; }

        /// <summary>
        /// Indicates whether a password is required to join the meeting
        /// </summary>
        public bool? passwordRequired { get; set; }

        /// <summary>
        /// The meeting status, i.e whether the meeting is running or not
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public MeetingStatus? status { get; set; }

        /// <summary>
        /// The subject of the meeting
        /// </summary>
        public string subject { get; set; }

        /// <summary>
        /// The meeting type
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public MeetingType? meetingType { get; set; }

        /// <summary>
        /// The ending time of the meeting
        /// </summary>
        public DateTime? endTime { get; set; }

        /// <summary>
        /// A unique ID for the meeting
        /// </summary>
        public long? uniqueMeetingId { get; set; }

        /// <summary>
        /// Audio options for the meeting
        /// </summary>
        public string conferenceCallInfo { get; set; }


        /// <summary>
        /// Returns a string representing the current object.
        /// </summary>
        /// <returns>The Json serialization of the current object.</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class MeetingByOrganizer {\n");
            var startTimeString = startTime.Stringify();
            if (!string.IsNullOrEmpty(startTimeString))
                sb.AppendFormat("  startTime: {0}\n", startTimeString);
            var createTimeString = createTime.Stringify();
            if (!string.IsNullOrEmpty(createTimeString))
                sb.AppendFormat("  createTime: {0}\n", createTimeString);
            var meetingidString = meetingid.Stringify();
            if (!string.IsNullOrEmpty(meetingidString))
                sb.AppendFormat("  meetingid: {0}\n", meetingidString);
            var maxParticipantsString = maxParticipants.Stringify();
            if (!string.IsNullOrEmpty(maxParticipantsString))
                sb.AppendFormat("  maxParticipants: {0}\n", maxParticipantsString);
            var passwordRequiredString = passwordRequired.Stringify();
            if (!string.IsNullOrEmpty(passwordRequiredString))
                sb.AppendFormat("  passwordRequired: {0}\n", passwordRequiredString);
            var statusString = status.Stringify();
            if (!string.IsNullOrEmpty(statusString))
                sb.AppendFormat("  status: {0}\n", statusString);
            var subjectString = subject.Stringify();
            if (!string.IsNullOrEmpty(subjectString))
                sb.AppendFormat("  subject: {0}\n", subjectString);
            var meetingTypeString = meetingType.Stringify();
            if (!string.IsNullOrEmpty(meetingTypeString))
                sb.AppendFormat("  meetingType: {0}\n", meetingTypeString);
            var endTimeString = endTime.Stringify();
            if (!string.IsNullOrEmpty(endTimeString))
                sb.AppendFormat("  endTime: {0}\n", endTimeString);
            var uniqueMeetingIdString = uniqueMeetingId.Stringify();
            if (!string.IsNullOrEmpty(uniqueMeetingIdString))
                sb.AppendFormat("  uniqueMeetingId: {0}\n", uniqueMeetingIdString);
            var conferenceCallInfoString = conferenceCallInfo.Stringify();
            if (!string.IsNullOrEmpty(conferenceCallInfoString))
                sb.AppendFormat("  conferenceCallInfo: {0}\n", conferenceCallInfoString);
            sb.Append("}\n");
            return sb.ToString();
        }
    }

}
