/*
 * © 2017 LogMeIn, Inc. All Rights Reserved.
 * All rights reserved.
 * 
 * This software is distributed under the terms and conditions of the
 * LogMeIn SDK License Agreement. Please see file LICENSE for details.
 * 
 * Auto-generated file.
 */


using System;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using LogMeIn.GoToMeeting.Api.Common;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;


namespace LogMeIn.GoToMeeting.Api.Model
{
    /// <summary>
    /// Describes a newly created meeting.
    /// </summary>
    public class MeetingCreated
    {
        /// <summary>
        /// The URL the meeting participants will use to join the meeting
        /// </summary>
        public string joinURL { get; set; }

        /// <summary>
        /// The meeting ID
        /// </summary>
        public long? meetingid { get; set; }

        /// <summary>
        /// The maximum number of participants allowed in the meeting
        /// </summary>
        public int? maxParticipants { get; set; }

        /// <summary>
        /// The meeting ID. Field retained for backwards compatibility reasons
        /// </summary>
        public long? uniqueMeetingId { get; set; }

        /// <summary>
        /// Audio options for the meeting
        /// </summary>
        public string conferenceCallInfo { get; set; }


        /// <summary>
        /// Returns a string representing the current object.
        /// </summary>
        /// <returns>The Json serialization of the current object.</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class MeetingCreated {\n");
            var joinURLString = joinURL.Stringify();
            if (!string.IsNullOrEmpty(joinURLString))
                sb.AppendFormat("  joinURL: {0}\n", joinURLString);
            var meetingidString = meetingid.Stringify();
            if (!string.IsNullOrEmpty(meetingidString))
                sb.AppendFormat("  meetingid: {0}\n", meetingidString);
            var maxParticipantsString = maxParticipants.Stringify();
            if (!string.IsNullOrEmpty(maxParticipantsString))
                sb.AppendFormat("  maxParticipants: {0}\n", maxParticipantsString);
            var uniqueMeetingIdString = uniqueMeetingId.Stringify();
            if (!string.IsNullOrEmpty(uniqueMeetingIdString))
                sb.AppendFormat("  uniqueMeetingId: {0}\n", uniqueMeetingIdString);
            var conferenceCallInfoString = conferenceCallInfo.Stringify();
            if (!string.IsNullOrEmpty(conferenceCallInfoString))
                sb.AppendFormat("  conferenceCallInfo: {0}\n", conferenceCallInfoString);
            sb.Append("}\n");
            return sb.ToString();
        }
    }

}
