/*
 * © 2017 LogMeIn, Inc. All Rights Reserved.
 * All rights reserved.
 * 
 * This software is distributed under the terms and conditions of the
 * LogMeIn SDK License Agreement. Please see file LICENSE for details.
 * 
 * Auto-generated file.
 */


using System;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using LogMeIn.GoToMeeting.Api.Common;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;


namespace LogMeIn.GoToMeeting.Api.Model
{
    /// <summary>
    /// Information about the meeting recording.
    /// </summary>
    public class MeetingRecording
    {
        /// <summary>
        /// Name of the recording
        /// </summary>
        public string recordingName { get; set; }

        /// <summary>
        /// Url where the mp4 file of the recording can be downloaded
        /// </summary>
        public string downloadUrl { get; set; }

        /// <summary>
        /// Time until when the recording is available for download
        /// </summary>
        public DateTime? downloadUrlValidUntil { get; set; }

        /// <summary>
        /// Size of the recording file in bytes
        /// </summary>
        public long? fileSize { get; set; }

        /// <summary>
        /// Url that can be used to share the recording only or including transcripts if present
        /// </summary>
        public string shareUrl { get; set; }


        /// <summary>
        /// Returns a string representing the current object.
        /// </summary>
        /// <returns>The Json serialization of the current object.</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class MeetingRecording {\n");
            var recordingNameString = recordingName.Stringify();
            if (!string.IsNullOrEmpty(recordingNameString))
                sb.AppendFormat("  recordingName: {0}\n", recordingNameString);
            var downloadUrlString = downloadUrl.Stringify();
            if (!string.IsNullOrEmpty(downloadUrlString))
                sb.AppendFormat("  downloadUrl: {0}\n", downloadUrlString);
            var downloadUrlValidUntilString = downloadUrlValidUntil.Stringify();
            if (!string.IsNullOrEmpty(downloadUrlValidUntilString))
                sb.AppendFormat("  downloadUrlValidUntil: {0}\n", downloadUrlValidUntilString);
            var fileSizeString = fileSize.Stringify();
            if (!string.IsNullOrEmpty(fileSizeString))
                sb.AppendFormat("  fileSize: {0}\n", fileSizeString);
            var shareUrlString = shareUrl.Stringify();
            if (!string.IsNullOrEmpty(shareUrlString))
                sb.AppendFormat("  shareUrl: {0}\n", shareUrlString);
            sb.Append("}\n");
            return sb.ToString();
        }
    }

}
