/*
 * © 2017 LogMeIn, Inc. All Rights Reserved.
 * All rights reserved.
 * 
 * This software is distributed under the terms and conditions of the
 * LogMeIn SDK License Agreement. Please see file LICENSE for details.
 * 
 * Auto-generated file.
 */


using System;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using LogMeIn.GoToMeeting.Api.Common;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;


namespace LogMeIn.GoToMeeting.Api.Model
{
    /// <summary>
    /// Describes the information required to update a meeting.
    /// </summary>
    public class MeetingReqUpdate
    {
        /// <summary>
        /// A description of the meeting. 100 characters maximum. The characters '&gt;' and '&lt;' have to be replaced with the corresponding html character code (&amp;gt; for &#39;&gt;&#39; and &amp;lt; for &#39;&lt;&#39;)
        /// </summary>
        public string subject { get; set; }

        /// <summary>
        /// The starting time of the meeting. A required ISO8601 UTC string, e.g. 2015-07-01T22:00:00Z
        /// </summary>
        public DateTime? starttime { get; set; }

        /// <summary>
        /// The ending time of the meeting. A required ISO8601 UTC string, e.g. 2015-07-01T22:00:00Z
        /// </summary>
        public DateTime? endtime { get; set; }

        /// <summary>
        /// Indicates whether a password is required to join the meeting. Required parameter
        /// </summary>
        public bool? passwordrequired { get; set; }

        /// <summary>
        /// A required string. Can be one of the following options: <para/>PSTN (PSTN only), <para/>Free (PSTN and VoIP), <para/>Hybrid, (PSTN and VoIP), <para/>Private (you provide numbers and access code), or <para/>VoIP (VoIP only). <para/>You may also enter plain text for numbers and access codes with a limit of 255 characters
        /// </summary>
        public string conferencecallinfo { get; set; }

        /// <summary>
        /// DEPRECATED. Must be provided and set to empty string ''
        /// </summary>
        [Obsolete]
        public string timezonekey { get; set; }

        /// <summary>
        /// The meeting type
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public MeetingType? meetingtype { get; set; }

        /// <summary>
        /// Co-organizer keys. Co-organizers can start the meeting on the organizers behalf. Retrieve a list of valid organizers from the \"Get all organizers\" call.
        /// </summary>
        public List<string> coorganizerKeys { get; set; }


        /// <summary>
        /// Returns a string representing the current object.
        /// </summary>
        /// <returns>The Json serialization of the current object.</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class MeetingReqUpdate {\n");
            var subjectString = subject.Stringify();
            if (!string.IsNullOrEmpty(subjectString))
                sb.AppendFormat("  subject: {0}\n", subjectString);
            var starttimeString = starttime.Stringify();
            if (!string.IsNullOrEmpty(starttimeString))
                sb.AppendFormat("  starttime: {0}\n", starttimeString);
            var endtimeString = endtime.Stringify();
            if (!string.IsNullOrEmpty(endtimeString))
                sb.AppendFormat("  endtime: {0}\n", endtimeString);
            var passwordrequiredString = passwordrequired.Stringify();
            if (!string.IsNullOrEmpty(passwordrequiredString))
                sb.AppendFormat("  passwordrequired: {0}\n", passwordrequiredString);
            var conferencecallinfoString = conferencecallinfo.Stringify();
            if (!string.IsNullOrEmpty(conferencecallinfoString))
                sb.AppendFormat("  conferencecallinfo: {0}\n", conferencecallinfoString);
            var timezonekeyString = timezonekey.Stringify();
            if (!string.IsNullOrEmpty(timezonekeyString))
                sb.AppendFormat("  timezonekey: {0}\n", timezonekeyString);
            var meetingtypeString = meetingtype.Stringify();
            if (!string.IsNullOrEmpty(meetingtypeString))
                sb.AppendFormat("  meetingtype: {0}\n", meetingtypeString);
            var coorganizerKeysString = coorganizerKeys.Stringify();
            if (!string.IsNullOrEmpty(coorganizerKeysString))
                sb.AppendFormat("  coorganizerKeys: {0}\n", coorganizerKeysString);
            sb.Append("}\n");
            return sb.ToString();
        }
    }

}
