/*
 * © 2017 LogMeIn, Inc. All Rights Reserved.
 * All rights reserved.
 * 
 * This software is distributed under the terms and conditions of the
 * LogMeIn SDK License Agreement. Please see file LICENSE for details.
 * 
 * Auto-generated file.
 */


using System;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using LogMeIn.GoToMeeting.Api.Common;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;


namespace LogMeIn.GoToMeeting.Api.Model
{
    /// <summary>
    /// Describes an organizer within a specified group.
    /// </summary>
    public class OrganizerByGroup
    {
        /// <summary>
        /// The organizer's surname
        /// </summary>
        public string lastName { get; set; }

        /// <summary>
        /// The key of the group
        /// </summary>
        public long? groupId { get; set; }

        /// <summary>
        /// The name of the group
        /// </summary>
        public string groupName { get; set; }

        /// <summary>
        /// The status of the organizer, i.e. whether the organizer is able to host meetings
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public Status? status { get; set; }

        /// <summary>
        /// The organizer's email address
        /// </summary>
        public string email { get; set; }

        /// <summary>
        /// The key of the organizer
        /// </summary>
        public long? organizerKey { get; set; }

        /// <summary>
        /// The organizer's first name
        /// </summary>
        public string firstName { get; set; }

        /// <summary>
        /// The products the organizer has access to, can be 'G2M', 'G2W', 'G2T' or 'OPENVOICE'
        /// </summary>
        [JsonProperty(ItemConverterType = typeof(StringEnumConverter))]
        public List<Product> products { get; set; }

        /// <summary>
        /// The maximum number of attendees allowed at sessions held by this organizer
        /// </summary>
        public int? maxNumAttendeesAllowed { get; set; }


        /// <summary>
        /// Returns a string representing the current object.
        /// </summary>
        /// <returns>The Json serialization of the current object.</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class OrganizerByGroup {\n");
            var lastNameString = lastName.Stringify();
            if (!string.IsNullOrEmpty(lastNameString))
                sb.AppendFormat("  lastName: {0}\n", lastNameString);
            var groupIdString = groupId.Stringify();
            if (!string.IsNullOrEmpty(groupIdString))
                sb.AppendFormat("  groupId: {0}\n", groupIdString);
            var groupNameString = groupName.Stringify();
            if (!string.IsNullOrEmpty(groupNameString))
                sb.AppendFormat("  groupName: {0}\n", groupNameString);
            var statusString = status.Stringify();
            if (!string.IsNullOrEmpty(statusString))
                sb.AppendFormat("  status: {0}\n", statusString);
            var emailString = email.Stringify();
            if (!string.IsNullOrEmpty(emailString))
                sb.AppendFormat("  email: {0}\n", emailString);
            var organizerKeyString = organizerKey.Stringify();
            if (!string.IsNullOrEmpty(organizerKeyString))
                sb.AppendFormat("  organizerKey: {0}\n", organizerKeyString);
            var firstNameString = firstName.Stringify();
            if (!string.IsNullOrEmpty(firstNameString))
                sb.AppendFormat("  firstName: {0}\n", firstNameString);
            var productsString = products.Stringify();
            if (!string.IsNullOrEmpty(productsString))
                sb.AppendFormat("  products: {0}\n", productsString);
            var maxNumAttendeesAllowedString = maxNumAttendeesAllowed.Stringify();
            if (!string.IsNullOrEmpty(maxNumAttendeesAllowedString))
                sb.AppendFormat("  maxNumAttendeesAllowed: {0}\n", maxNumAttendeesAllowedString);
            sb.Append("}\n");
            return sb.ToString();
        }
    }

}
