/*
 * © 2017 LogMeIn, Inc. All Rights Reserved.
 * All rights reserved.
 * 
 * This software is distributed under the terms and conditions of the
 * LogMeIn SDK License Agreement. Please see file LICENSE for details.
 * 
 * Auto-generated file.
 */


using System;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using LogMeIn.GoToMeeting.Api.Common;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;


namespace LogMeIn.GoToMeeting.Api.Model
{
    /// <summary>
    /// Describes the information required to create an organizer, with or without assigning a group.
    /// </summary>
    public class OrganizerReq
    {
        /// <summary>
        /// The email address of the organizer
        /// </summary>
        public string organizerEmail { get; set; }

        /// <summary>
        /// The first name of the organizer
        /// </summary>
        public string firstName { get; set; }

        /// <summary>
        /// The surname of the organizer
        /// </summary>
        public string lastName { get; set; }

        /// <summary>
        /// A product the organizer has access to, can be 'G2M', 'G2W', 'G2T' or 'OPENVOICE'
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public Product? productType { get; set; }


        /// <summary>
        /// Returns a string representing the current object.
        /// </summary>
        /// <returns>The Json serialization of the current object.</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class OrganizerReq {\n");
            var organizerEmailString = organizerEmail.Stringify();
            if (!string.IsNullOrEmpty(organizerEmailString))
                sb.AppendFormat("  organizerEmail: {0}\n", organizerEmailString);
            var firstNameString = firstName.Stringify();
            if (!string.IsNullOrEmpty(firstNameString))
                sb.AppendFormat("  firstName: {0}\n", firstNameString);
            var lastNameString = lastName.Stringify();
            if (!string.IsNullOrEmpty(lastNameString))
                sb.AppendFormat("  lastName: {0}\n", lastNameString);
            var productTypeString = productType.Stringify();
            if (!string.IsNullOrEmpty(productTypeString))
                sb.AppendFormat("  productType: {0}\n", productTypeString);
            sb.Append("}\n");
            return sb.ToString();
        }
    }

}
