/*
 * © 2017 LogMeIn, Inc. All Rights Reserved.
 * All rights reserved.
 * 
 * This software is distributed under the terms and conditions of the
 * LogMeIn SDK License Agreement. Please see file LICENSE for details.
 * 
 * Auto-generated file.
 */


using System;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using LogMeIn.GoToMeeting.Api.Common;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;


namespace LogMeIn.GoToMeeting.Api.Model
{
    /// <summary>
    /// Describes the status of an organizer, i.e. whether they are able to host meetings.
    /// </summary>
    public class OrganizerStatus
    {
        /// <summary>
        /// The status of the organizer can be set to. Use 'suspended' to remove all products. The formerly used status 'active' is now DEPRECATED for this call. To activate the organizer please assign a product. In this case do not pass this parameter
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public StatusEnum? status { get; set; }

        /// <summary>
        /// The product you want to add to the organizer. The call must be sent once for each product you want to add
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public Product? productType { get; set; }

        /// <summary>
        /// The status of the organizer can be set to. Use 'suspended' to remove all products. The formerly used status 'active' is now DEPRECATED for this call. To activate the organizer please assign a product. In this case do not pass this parameter
        /// </summary>
        public enum StatusEnum
        {
            /// <summary>
            ///
            /// </summary>
            suspended,
        };


        /// <summary>
        /// Returns a string representing the current object.
        /// </summary>
        /// <returns>The Json serialization of the current object.</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class OrganizerStatus {\n");
            var statusString = status.Stringify();
            if (!string.IsNullOrEmpty(statusString))
                sb.AppendFormat("  status: {0}\n", statusString);
            var productTypeString = productType.Stringify();
            if (!string.IsNullOrEmpty(productTypeString))
                sb.AppendFormat("  productType: {0}\n", productTypeString);
            sb.Append("}\n");
            return sb.ToString();
        }
    }

}
