/*
 * © 2017 LogMeIn, Inc. All Rights Reserved.
 * All rights reserved.
 * 
 * This software is distributed under the terms and conditions of the
 * LogMeIn SDK License Agreement. Please see file LICENSE for details.
 * 
 * Auto-generated file.
 */


using System;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using LogMeIn.GoToMeeting.Api.Common;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;


namespace LogMeIn.GoToMeeting.Api.Model
{
    /// <summary>
    /// Describes a meeting scheduled by an organizer within a specified group.
    /// </summary>
    public class ScheduledMeetingByGroup
    {
        /// <summary>
        /// The key of the meeting organizer. Field retained for backwards compatibility reasons.
        /// </summary>
        public long? organizerkey { get; set; }

        /// <summary>
        /// Not in use.
        /// </summary>
        public string attendees { get; set; }

        /// <summary>
        /// The surname of the meeting organizer.
        /// </summary>
        public string lastName { get; set; }

        /// <summary>
        /// The name of the group.
        /// </summary>
        public string groupName { get; set; }

        /// <summary>
        /// Indicates whether a password is required to join the meeting.
        /// </summary>
        public bool? passwordRequired { get; set; }

        /// <summary>
        /// The email address of the meeting organizer.
        /// </summary>
        public string email { get; set; }

        /// <summary>
        /// The subject of the meeting.
        /// </summary>
        public string subject { get; set; }

        /// <summary>
        /// The meeting ID.
        /// </summary>
        public string meetingId { get; set; }

        /// <summary>
        /// The key of the meeting organizer.
        /// </summary>
        public string organizerKey { get; set; }

        /// <summary>
        /// The meeting type
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public MeetingType? meetingType { get; set; }

        /// <summary>
        /// The first name of the meeting organizer.
        /// </summary>
        public string firstName { get; set; }

        /// <summary>
        /// Audio options for the meeting.
        /// </summary>
        public string conferenceCallInfo { get; set; }


        /// <summary>
        /// Returns a string representing the current object.
        /// </summary>
        /// <returns>The Json serialization of the current object.</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ScheduledMeetingByGroup {\n");
            var organizerkeyString = organizerkey.Stringify();
            if (!string.IsNullOrEmpty(organizerkeyString))
                sb.AppendFormat("  organizerkey: {0}\n", organizerkeyString);
            var attendeesString = attendees.Stringify();
            if (!string.IsNullOrEmpty(attendeesString))
                sb.AppendFormat("  attendees: {0}\n", attendeesString);
            var lastNameString = lastName.Stringify();
            if (!string.IsNullOrEmpty(lastNameString))
                sb.AppendFormat("  lastName: {0}\n", lastNameString);
            var groupNameString = groupName.Stringify();
            if (!string.IsNullOrEmpty(groupNameString))
                sb.AppendFormat("  groupName: {0}\n", groupNameString);
            var passwordRequiredString = passwordRequired.Stringify();
            if (!string.IsNullOrEmpty(passwordRequiredString))
                sb.AppendFormat("  passwordRequired: {0}\n", passwordRequiredString);
            var emailString = email.Stringify();
            if (!string.IsNullOrEmpty(emailString))
                sb.AppendFormat("  email: {0}\n", emailString);
            var subjectString = subject.Stringify();
            if (!string.IsNullOrEmpty(subjectString))
                sb.AppendFormat("  subject: {0}\n", subjectString);
            var meetingIdString = meetingId.Stringify();
            if (!string.IsNullOrEmpty(meetingIdString))
                sb.AppendFormat("  meetingId: {0}\n", meetingIdString);
            var organizerKeyString = organizerKey.Stringify();
            if (!string.IsNullOrEmpty(organizerKeyString))
                sb.AppendFormat("  organizerKey: {0}\n", organizerKeyString);
            var meetingTypeString = meetingType.Stringify();
            if (!string.IsNullOrEmpty(meetingTypeString))
                sb.AppendFormat("  meetingType: {0}\n", meetingTypeString);
            var firstNameString = firstName.Stringify();
            if (!string.IsNullOrEmpty(firstNameString))
                sb.AppendFormat("  firstName: {0}\n", firstNameString);
            var conferenceCallInfoString = conferenceCallInfo.Stringify();
            if (!string.IsNullOrEmpty(conferenceCallInfoString))
                sb.AppendFormat("  conferenceCallInfo: {0}\n", conferenceCallInfoString);
            sb.Append("}\n");
            return sb.ToString();
        }
    }

}
