/*
 * © 2017 LogMeIn, Inc. All Rights Reserved.
 * All rights reserved.
 * 
 * This software is distributed under the terms and conditions of the
 * LogMeIn SDK License Agreement. Please see file LICENSE for details.
 * 
 * Auto-generated file.
 */


using System;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using LogMeIn.GoToMeeting.Api.Common;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;


namespace LogMeIn.GoToMeeting.Api.Model
{
    /// <summary>
    /// Describes an upcoming meeting.
    /// </summary>
    public class UpcomingMeeting
    {
        /// <summary>
        /// The time the meeting instance will start
        /// </summary>
        public DateTime? startTime { get; set; }

        /// <summary>
        /// The surname of the meeting organizer
        /// </summary>
        public string lastName { get; set; }

        /// <summary>
        /// The key of the company account
        /// </summary>
        public string accountKey { get; set; }

        /// <summary>
        /// Indicates whether a password is required to join the meeting or not
        /// </summary>
        public bool? passwordRequired { get; set; }

        /// <summary>
        /// The meeting organizer's email address
        /// </summary>
        public string email { get; set; }

        /// <summary>
        /// The meeting status, i.e whether the meeting is running or not
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public MeetingStatus? status { get; set; }

        /// <summary>
        /// The subject of the meeting
        /// </summary>
        public string subject { get; set; }

        /// <summary>
        /// The current language setting of the organizer in the web portal
        /// </summary>
        public string locale { get; set; }

        /// <summary>
        /// The key of the meeting organizer
        /// </summary>
        public string organizerKey { get; set; }

        /// <summary>
        /// The meeting ID
        /// </summary>
        public string meetingId { get; set; }

        /// <summary>
        /// The meeting type
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public MeetingType? meetingType { get; set; }

        /// <summary>
        /// The meeting organizer's first name
        /// </summary>
        public string firstName { get; set; }

        /// <summary>
        /// The time the meeting instance ended
        /// </summary>
        public DateTime? endTime { get; set; }

        /// <summary>
        /// Audio options for the meeting
        /// </summary>
        public string conferenceCallInfo { get; set; }


        /// <summary>
        /// Returns a string representing the current object.
        /// </summary>
        /// <returns>The Json serialization of the current object.</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class UpcomingMeeting {\n");
            var startTimeString = startTime.Stringify();
            if (!string.IsNullOrEmpty(startTimeString))
                sb.AppendFormat("  startTime: {0}\n", startTimeString);
            var lastNameString = lastName.Stringify();
            if (!string.IsNullOrEmpty(lastNameString))
                sb.AppendFormat("  lastName: {0}\n", lastNameString);
            var accountKeyString = accountKey.Stringify();
            if (!string.IsNullOrEmpty(accountKeyString))
                sb.AppendFormat("  accountKey: {0}\n", accountKeyString);
            var passwordRequiredString = passwordRequired.Stringify();
            if (!string.IsNullOrEmpty(passwordRequiredString))
                sb.AppendFormat("  passwordRequired: {0}\n", passwordRequiredString);
            var emailString = email.Stringify();
            if (!string.IsNullOrEmpty(emailString))
                sb.AppendFormat("  email: {0}\n", emailString);
            var statusString = status.Stringify();
            if (!string.IsNullOrEmpty(statusString))
                sb.AppendFormat("  status: {0}\n", statusString);
            var subjectString = subject.Stringify();
            if (!string.IsNullOrEmpty(subjectString))
                sb.AppendFormat("  subject: {0}\n", subjectString);
            var localeString = locale.Stringify();
            if (!string.IsNullOrEmpty(localeString))
                sb.AppendFormat("  locale: {0}\n", localeString);
            var organizerKeyString = organizerKey.Stringify();
            if (!string.IsNullOrEmpty(organizerKeyString))
                sb.AppendFormat("  organizerKey: {0}\n", organizerKeyString);
            var meetingIdString = meetingId.Stringify();
            if (!string.IsNullOrEmpty(meetingIdString))
                sb.AppendFormat("  meetingId: {0}\n", meetingIdString);
            var meetingTypeString = meetingType.Stringify();
            if (!string.IsNullOrEmpty(meetingTypeString))
                sb.AppendFormat("  meetingType: {0}\n", meetingTypeString);
            var firstNameString = firstName.Stringify();
            if (!string.IsNullOrEmpty(firstNameString))
                sb.AppendFormat("  firstName: {0}\n", firstNameString);
            var endTimeString = endTime.Stringify();
            if (!string.IsNullOrEmpty(endTimeString))
                sb.AppendFormat("  endTime: {0}\n", endTimeString);
            var conferenceCallInfoString = conferenceCallInfo.Stringify();
            if (!string.IsNullOrEmpty(conferenceCallInfoString))
                sb.AppendFormat("  conferenceCallInfo: {0}\n", conferenceCallInfoString);
            sb.Append("}\n");
            return sb.ToString();
        }
    }

}
